function AssignFieldValuesToCaller(oGridRow, fieldId, windowToUse, withSearch) {
    var referencedFieldsArray = windowToUse.referencedFieldsArray;

    try {
        windowToUse.document.form1.elements["field" + fieldId + "_PK"].value = oGridRow.getCell(1).getValue();
        for (var i = 0; i < referencedFieldsArray.length; i++) {
            if (referencedFieldsArray[i][1] == fieldId) {
                //this is the required group
                //alert("found relevant field group");
                var grid = oGridRow.parent;
                //assign the data for the primary field
                if (withSearch) {
                    AssignFieldValue(windowToUse, referencedFieldsArray[i][5], referencedFieldsArray[i][4], "field" + fieldId, "__" + "field" + fieldId + "_text", oGridRow, 4);
                }
                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[i][6]; derivedFieldIndex++) {
                    AssignFieldValue(windowToUse, referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 1], "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)], "__" + "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)] + "_text", oGridRow, 5 + derivedFieldIndex);
                }
                break;
            }
        }
    }
    catch (e) {

        var element = null;
        for (var iFind = 0; iFind < windowToUse.document.form1.elements.length; iFind++) {
            element = windowToUse.document.form1.elements[iFind];
            if (element.id.indexOf("field" + fieldId + "_PK") != -1) {
                break;
            }

        }
        var elementID = element.id;
        try {
            windowToUse.document.form1.elements[elementID].value = oGridRow.getCell(1).getValue();
            var eText = elementID.substr(0, elementID.length - 3);
            var radID = eText.substr(0, eText.indexOf("field" + fieldId));
            for (var iLoop = 0; iLoop < referencedFieldsArray.length; iLoop++) {
                if (referencedFieldsArray[iLoop][1] == fieldId) {
                    //alert(referencedFieldsArray[i][1].toString() + " equals " + fieldId);

                    //this is the required group
                    //alert("found relevant field group");
                    var grid = oGridRow.parent;
                    //assign the data for the primary field
                    if (withSearch) {
                        AssignFieldValue(windowToUse, referencedFieldsArray[iLoop][5], referencedFieldsArray[iLoop][4], eText, "__" + eText + "_text", oGridRow, 4);
                    }
                    for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[iLoop][6]; derivedFieldIndex++) {
                        AssignFieldValue(windowToUse, referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1], radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)], "__" + radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)] + "_text", oGridRow, 5 + derivedFieldIndex);
                    }
                    break;
                }
            }
        }
        catch (ea) {
        }
    }
}

function AssignFieldValue(windowToUse, renderAs, isHyperLinked, spanIdToReceiveValue, textIdToHoldData, oGridRow, cellIndexForValue) {
    //alert(windowToUse.toString() + "  " + renderAs.toString() + "  " + isHyperLinked.toString() + "  " + spanIdToReceiveValue.toString() + "  " + textIdToHoldData.toString() + "  " + oGridRow.getCell(cellIndexForValue).getValue().toString() + "  " + cellIndexForValue.toString() + "  " + oGridRow.getCell(2).getValue().toString());
    if (renderAs == "Upload") {
        windowToUse.document.getElementById(spanIdToReceiveValue).innerHTML = ExtractLink(oGridRow.getCell(cellIndexForValue));
        windowToUse.document.form1.elements[textIdToHoldData].value = ExtractLink(oGridRow.getCell(cellIndexForValue));
    }
    else {
        if (isHyperLinked) {
            windowToUse.document.getElementById(spanIdToReceiveValue).innerHTML = GetHyperlinkToObject(oGridRow.getCell(3).getValue(), oGridRow.getCell(1).getValue(), oGridRow.getCell(cellIndexForValue).getValue());
            windowToUse.document.form1.elements[textIdToHoldData].value = GetHyperlinkToObject(oGridRow.getCell(2).getValue(), oGridRow.getCell(1).getValue(), oGridRow.getCell(cellIndexForValue).getValue());
        }
        else {
            SetText(windowToUse.document.getElementById(spanIdToReceiveValue), oGridRow.getCell(cellIndexForValue).getValue());
            windowToUse.document.form1.elements[textIdToHoldData].value = oGridRow.getCell(cellIndexForValue).getValue();
        }
    }
}

function ClearReferenceFields(fieldId, windowToUse, withSearch) {
    var referencedFieldsArray = windowToUse.referencedFieldsArray;
    try {
        windowToUse.document.form1.elements["field" + fieldId + "_PK"].value = "";
        for (i = 0; i < referencedFieldsArray.length; i++) {
            if (referencedFieldsArray[i][1] == fieldId) {
                if (withSearch) {
                    SetText(windowToUse.document.getElementById("field" + fieldId), "");
                    windowToUse.document.form1.elements["__" + "field" + fieldId + "_text"].value = "";
                }
                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[i][6]; derivedFieldIndex++) {
                    SetText(windowToUse.document.getElementById("field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)]), "");
                    windowToUse.document.form1.elements["__" + "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)] + "_text"].value = "";
                }
            }
        }
    }
    catch (e) {
        var element = null;
        for (var iFind = 0; iFind < windowToUse.document.form1.elements.length; iFind++) {
            element = windowToUse.document.form1.elements[iFind];
            if (element.id.indexOf("field" + fieldId + "_PK") != -1) {
                break;
            }

        }

        var elementID = element.id;
        windowToUse.document.form1.elements[elementID].value = "";
        var eText = elementID.substr(0, elementID.length - 3);
        var radID = eText.substr(0, eText.indexOf("field" + fieldId));
        for (iFind = 0; iFind < referencedFieldsArray.length; iFind++) {
            if (referencedFieldsArray[iFind][1] == fieldId) {
                if (withSearch) {
                    SetText(windowToUse.document.getElementById(eText), "");
                    windowToUse.document.form1.elements["__" + eText + "_text"].value = "";
                }
                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[iFind][6]; derivedFieldIndex++) {
                    SetText(windowToUse.document.getElementById(radID + "field" + referencedFieldsArray[iFind][7 + (derivedFieldIndex * 4)]), "");
                    windowToUse.document.form1.elements["__" + radID + "field" + referencedFieldsArray[iFind][7 + (derivedFieldIndex * 4)] + "_text"].value = "";
                }
            }
        }


    }
}

function ExtractLink(oCell) {
    var innerHTML = new String(oCell.Element.innerHTML);
    var nobrString = new String("<NOBR>");
    var nobrEndString = new String("</NOBR>");
    var iNobrEndIndex;
    iNobrEndIndex = innerHTML.indexOf(nobrEndString.toString());
    return innerHTML.substring(nobrString.length, iNobrEndIndex);
}

function GetHyperlinkToObject(typeId, objectId, linkTitle) {
    return "<a href='EntityObject.aspx?TypeId=" + typeId + "&ObjectId=" + objectId + "' class='hyperlink'>" + linkTitle + "</a>";
}

function ReplaceDoubleQuotes(textbox) {
    //alert(textbox.value);
    var singleQuote = "'";
    textbox.value = textbox.value.replace(/"/g, singleQuote);
}

function AssignFieldValuesToCallerForNew(objectId, baseObjectId, referenceFieldValue, fieldId, windowToUse, withSearch, referenceFieldValueArray, referenceFieldValueArrayID) {

    //alert(windowToUse);
    var referencedFieldsArray = windowToUse.referencedFieldsArray;

    try {
        //alert(windowToUse.document.form1.elements["field" + fieldId + "_PK"].value);

        //alert("New ObjectId"+objectId.toString());
        
        //alert(windowToUse.document.form1.elements["field" + fieldId + "_PK"].type);
        windowToUse.document.form1.elements["field" + fieldId + "_PK"].value = objectId;
        for (var i = 0; i < referencedFieldsArray.length; i++) {
            if (referencedFieldsArray[i][1] == fieldId) {
                //this is the required group
                //alert("found relevant field group");
                //var grid = oGridRow.parent;
                //assign the data for the primary field
                if (withSearch) {
                    AssignFieldValueForNew(windowToUse, referencedFieldsArray[i][5], referencedFieldsArray[i][4], "field" + fieldId, "__" + "field" + fieldId + "_text", objectId, baseObjectId, referenceFieldValue, 4);
                }
                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[i][6]; derivedFieldIndex++) {
                    for (var j = 0; j < referenceFieldValueArrayID.length; j++) {
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4)].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 1].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 3].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        if (referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 3] == referenceFieldValueArrayID[j]) {
                            AssignFieldValueForNew(windowToUse, referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 1], "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)], "__" + "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)] + "_text", objectId, baseObjectId, referenceFieldValueArray[j], 5 + derivedFieldIndex);
                        }
                    }
                }

                //                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[i][6]; derivedFieldIndex++) {
                //                    if (referenceFieldValueArray[derivedFieldIndex + 1] != 'undefined') {
                //                        AssignFieldValueForNew(windowToUse, referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 1], "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)], "__" + "field" + referencedFieldsArray[i][7 + (derivedFieldIndex * 4)] + "_text", objectId, baseObjectId, referenceFieldValueArray[derivedFieldIndex + 1], 5 + derivedFieldIndex);
                //                    }
                //                    
                //                }


                break;
            }
        }
    }
    catch (e) {

        var element = null;
        for (var iFind = 0; iFind < windowToUse.document.form1.elements.length; iFind++) {
            element = windowToUse.document.form1.elements[iFind];
            if (element.id.indexOf("field" + fieldId + "_PK") != -1) {
                break;
            }

        }
        var elementID = element.id;
        windowToUse.document.form1.elements[elementID].value = objectId;
        //alert("in Catch" + windowToUse.document.form1.elements[elementID].value.toString() + " Objectid=" + objectId);
        var eText = elementID.substr(0, elementID.length - 3);
        var radID = eText.substr(0, eText.indexOf("field" + fieldId));
        //alert(radID.toString());
        for (var iLoop = 0; iLoop < referencedFieldsArray.length; iLoop++) {
            //alert(referencedFieldsArray[iLoop][1].toString() + " equals " + fieldId);
            if (referencedFieldsArray[iLoop][1] == fieldId) {
                //this is the required group
                //alert("found relevant field group");
                //var grid = oGridRow.parent;
                //assign the data for the primary field
                if (withSearch) {
                    AssignFieldValueForNew(windowToUse, referencedFieldsArray[iLoop][5], referencedFieldsArray[iLoop][4], radID.toString() + "field" + fieldId, "__" + radID.toString() + "field" + fieldId + "_text", objectId, baseObjectId, referenceFieldValue, 4);
                    //AssignFieldValueForNew(windowToUse, referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1], radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)], "__" + radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)] + "_text", objectId, baseObjectId, referenceFieldValueArray[j], 5 + derivedFieldIndex);

                    //AssignFieldValueForNew(windowToUse, referencedFieldsArray[iLoop][5], referencedFieldsArray[iLoop][4], eText, "__" + eText + "_text", objectId, baseObjectId, referenceFieldValue, 4);
                }
                for (var derivedFieldIndex = 0; derivedFieldIndex < referencedFieldsArray[iLoop][6]; derivedFieldIndex++) {
                    for (var j = 0; j < referenceFieldValueArrayID.length; j++) {
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4)].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 1].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        //alert(referencedFieldsArray[i][7 + (derivedFieldIndex * 4) + 3].toString() + " = " + referenceFieldValueArrayID[j].toString());
                        if (referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 3] == referenceFieldValueArrayID[j]) {
                            //alert(windowToUse.toString(), referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1].toString(), radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)].toString(), "__" + radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)].toString() + "_text", objectId.toString(), baseObjectId.toString(), referenceFieldValueArray[j].toString(), 5 + derivedFieldIndex.toString());
                            AssignFieldValueForNew(windowToUse, referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1], radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)], "__" + radID.toString() + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)] + "_text", objectId, baseObjectId, referenceFieldValueArray[j], 5 + derivedFieldIndex);
                            //AssignFieldValue(windowToUse, referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1], radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)], "__" + radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)] + "_text", oGridRow, 5 + derivedFieldIndex);

                        }
                    }

                    //AssignFieldValueForNew(windowToUse, referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 2], referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4) + 1], radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)], "__" + radID + "field" + referencedFieldsArray[iLoop][7 + (derivedFieldIndex * 4)] + "_text", objectId, baseObjectId, referenceFieldValue, 5 + derivedFieldIndex);
                }
                break;
            }
        }
    }
}
function AssignFieldValueForNew(windowToUse, renderAs, isHyperLinked, spanIdToReceiveValue, textIdToHoldData, objectId, baseObjectId, referenceFieldValue, cellIndexForValue) {
    //alert(windowToUse.toString() + "  " + renderAs.toString() + "  " + isHyperLinked.toString() + "  " + spanIdToReceiveValue.toString() + "  " + textIdToHoldData.toString() + "  " + cellIndexForValue.toString() + "  " + "ObjectId: " + objectId.toString() + "BaseObjectId: " + baseObjectId.toString() + "Value: " + referenceFieldValue.toString());

    //alert(windowToUse.toString() + renderAs.toString() + isHyperLinked.toString() + spanIdToReceiveValue.toString() +"TextIdToHoldData: "+ textIdToHoldData.toString() +"ObjectId: "+ objectId.toString() + baseObjectId.toString() + referenceFieldValue.toString() + cellIndexForValue.toString());
    if (renderAs == "Upload") {
        windowToUse.document.getElementById(spanIdToReceiveValue).innerHTML = ExtractLink(referenceFieldValue);
        windowToUse.document.form1.elements[textIdToHoldData].value = ExtractLink(referenceFieldValue);
    }
    else {
        if (isHyperLinked && typeof (windowToUse.document.getElementById(spanIdToReceiveValue).type) == 'undefined') {
            windowToUse.document.getElementById(spanIdToReceiveValue).innerHTML = GetHyperlinkToObject(baseObjectId, objectId, referenceFieldValue);
            windowToUse.document.form1.elements[textIdToHoldData].value = GetHyperlinkToObject(baseObjectId, objectId, referenceFieldValue);
        }
        else {
            //alert(windowToUse.document.getElementById(spanIdToReceiveValue).type);
            if (typeof (windowToUse.document.getElementById(spanIdToReceiveValue).type) != 'undefined' && windowToUse.document.getElementById(spanIdToReceiveValue).type.toString() == 'select-one') {
                //alert("From ReferenceFieldsCommon");
                windowToUse.addOption(spanIdToReceiveValue, referenceFieldValue, objectId);
            }
            else {
                SetText(windowToUse.document.getElementById(spanIdToReceiveValue), referenceFieldValue);
                windowToUse.document.form1.elements[textIdToHoldData].value = referenceFieldValue;
            }
        }
    }
}